VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FishSmartBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ----------------------------------------------------------------------------------------
'
' FishSmartBox(FishSBox.cls)                                        Ulrich Mller 18.04.03
'                                                                   PCS1700          VB6.0
' FishFace fr die SmartBox
' Version with Raise ESC - NotHalt
'
' ----------------------------------------------------------------------------------------

Option Explicit

' --- Konstanten -------------------------------------------------------

Private Const sbxErrBasis& = 30000
Private Const sbxFehler = &H1FFFF

' --- Enums -----------------------------------------------------------

Public Enum sbxPort
  COM1 = 1
  COM2 = 2
  COM3 = 3
  COM4 = 4
End Enum

Public Enum sbxDir
  sbxLeft = 1
  sbxRight = 2
  sbxLinks = 1
  sbxRechts = 2
  sbxOff = 0
  sbxOn = 1
  sbxAus = 0
  sbxEin = 1
End Enum

Public Enum sbxDigIn
  sbxS0 = 1
  sbxS1 = 2
  sbxS2 = 3
  sbxS3 = 4
  sbxS4 = 5
  sbxS5 = 6
  sbxS6 = 7
  sbxS7 = 8
End Enum

Public Enum sbxDigOut
  sbxL0 = 1
  sbxL1 = 2
  sbxL2 = 3
  sbxL3 = 4
  sbxL4 = 5
  sbxL5 = 6
  sbxL6 = 7
  sbxL7 = 8
End Enum

Public Enum sbxAnalog
  sbxAA = 1
  sbxAB = 2
  sbxAC = 3
  sbxAD = 4
End Enum

Public Enum sbxMotor
  sbxMA = 1
  sbxMB = 2
  sbxMC = 3
  sbxMD = 4
End Enum

Private FNotHalt As Boolean              ' --- NotHalt Status
Private FOpen As Boolean                 ' --- Open Status
Private FDigOut&                         ' --- Status der Digitalausgnge

Private SMaske&(1 To 8)                  ' --- Maskieren bits in DigIn/Out (1-8)

Private comI As Long                     ' --- COM-Handle
Private comIDCB As dcbType               ' --- COM Daten
Private comITimeOuts As COMMTIMEOUTS
Private overL As OVERLAPPED

Private Function ClearIfBreak() As Boolean
  ClearIfBreak = False
  If FNotHalt Or (GetAsyncKeyState(VK_ESCAPE) <> 0) Then
    ClearLamps
    ClearMotors
    ClearIfBreak = True
  End If
End Function

Private Sub LowResADC()
Dim res&, w&
  res = WriteFile(comI, Chr$(45), 1, w, overL)
End Sub

Public Sub ClearLamps()

' ------ Ausschalten aller Digital-Ausgnge --------------------------------------------

Dim w&

  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.ClearMotors", "Kein Open"
  If WriteFile(comI, Chr$(20) & Chr$(0), 2, w, overL) = 0 Then Err.Raise sbxErrBasis + 1, _
    "FishSBox.ClearLamps", "SmartBox Problem"
  FDigOut = 0
  
End Sub

Public Sub ClearMotors()

' ------ Ausschalten aller Motor-Ausgnge --------------------------------------------

Dim w&

  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.ClearMotors", "Kein Open"
  If WriteFile(comI, Chr$(10) & Chr$(0), 2, w, overL) = 0 Then Err.Raise sbxErrBasis + 1, _
    "FishSBox.ClearMotors", "SmartBox Problem"
  
End Sub


Public Sub CloseInterface()

' --- Schlieen des COM-Ports --------------------------

  If Not FOpen Then Exit Sub
  ClearLamps
  ClearMotors
  CloseHandle comI
  FOpen = False
  
End Sub


Public Function Finish(Optional ByVal InputNr As sbxDigIn = 0) As Boolean

' --- Feststellen Endewunsch (NotHalt, Escape, InputNr) ------------------

  DoEvents
  Finish = True
  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.Finish", "Kein Open"
  If ClearIfBreak Then Exit Function
  If InputNr > 0 Then If GetInput(InputNr) Then Exit Function
  Finish = False
  
End Function

Public Function GetAnalog(ByVal AnalogNr As sbxAnalog) As Long

' --- Bestimmen des Status des Analog-Einganges AnalogNr ----

Dim wrk As String * 12, w&

  DoEvents
  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.GetAnalog", "Kein Open"
  If ClearIfBreak Then Exit Function
  If WriteFile(comI, Chr$(40) & Chr$(AnalogNr), 2, w, overL) = 0 Then _
     Err.Raise sbxErrBasis + 1, "FishSBox.GetAnalog", "SmartBox Problem"
  If ReadFile(comI, wrk, 1, w, overL) = 0 Then Err.Raise sbxErrBasis + 1, _
    "FishSBox.GetAnalog", "SmartBox Problem"
  If w = 0 Then GetAnalog = sbxFehler Else GetAnalog = Asc(wrk)
  
End Function

Public Function GetInput(ByVal InputNr As sbxDigIn) As Boolean

' --- Bestimmen des Status des Digital-Einganges InputNr ----

Dim wrk As String * 12, w&

  DoEvents
  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.GetInput", "Kein Open"
  If ClearIfBreak Then Exit Function
  If WriteFile(comI, Chr$(91) & Chr$(InputNr), 2, w, overL) = 0 Then _
     Err.Raise sbxErrBasis + 1, "FishSBox.GetInput", "SmartBox Problem"
  If ReadFile(comI, wrk, 1, w, overL) = 0 Then Err.Raise sbxErrBasis + 1, _
    "FishSBox.GetInput", "SmartBox Problem"
  GetInput = IIf(Asc(wrk) = 1, True, False)
  
End Function

Public Function GetInputs() As Long

' ---Auslesen Status aller Digital-Eingnge ---------------------

Dim wrk As String * 12, w&

  DoEvents
  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.GetInputs", "Kein Open"
  If ClearIfBreak Then Exit Function
  If WriteFile(comI, Chr$(90), 1, w, overL) = 0 Then Err.Raise sbxErrBasis + 1, _
    "FishSBox.GetInputs", "SmartBox Problem"
  If ReadFile(comI, wrk, 1, w, overL) = 0 Then Err.Raise sbxErrBasis + 1, _
    "FishSBox.GetInputs", "SmartBox Problem"
  If w = 0 Then GetInputs = sbxFehler Else GetInputs = Asc(wrk)

End Function

Public Sub OpenInterface(ByVal PortName As sbxPort)

' --- Verbindung zur SmartBox herstellen ---------------

Dim res&, w&, wrk As String * 256

' --- ffnen des COM-Ports ----------------------------------
'     Lesen und Schreiben zulssig, exklusiv, keine Security,
'     mu vorh. sein, normale Attribute (kein Overlapp),kein Tempfile

  
  comITimeOuts.ReadIntervalTimeout = 16
  comITimeOuts.ReadTotalTimeoutMultiplier = 4
  comITimeOuts.ReadTotalTimeOutConstant = 30
  comITimeOuts.WriteTotalTimeoutMultiplier = 1
  comITimeOuts.WriteTotalTimeoutConstant = 10

  overL.hEvent = 0
  overL.offset = 0
  overL.OffsetHigh = 0
  
  comI = CreateFile("COM" & Format$(PortName), GENERIC_READ Or GENERIC_WRITE, 0, 0, _
                    OPEN_EXISTING, 0&, 0)
  If comI = INVALID_HANDLE_VALUE Then Err.Raise sbxErrBasis + 1, _
    "FishSBox.OpenInterface", "COM Problem"
  
' --- ModemSettings --------------------------------------------------

  res = GetCommState(comI, comIDCB)
  
  comIDCB.BaudRate = 9600
  comIDCB.ByteSize = 8
  comIDCB.Parity = NOPARITY
  comIDCB.StopBits = ONESTOPBIT
  
  res = SetCommState(comI, comIDCB)
  
' --- TimeOuts einstellen : pro gelesenes Byte 4 ms + 30 ms gesamt ---

  res = SetCommTimeouts(comI, comITimeOuts)
  
' --- Prfen ob SmartBox vorhanden --------------------------------------
  
  FOpen = True
  If WriteFile(comI, Chr$(90), 1, w, overL) = 0 Then Err.Raise sbxErrBasis + 1, _
    "FishSBox.GetInputs", "SmartBox Problem"
  If ReadFile(comI, wrk, 12, w, overL) = 0 Then Err.Raise sbxErrBasis + 1, _
    "FishSBox.GetInputs", "SmartBox Problem"
  If w = 0 Then
    CloseInterface
    Err.Raise sbxErrBasis + 1, "FishSBox.OpenInterface", "SmartBox Problem"
  End If

  FNotHalt = False
  FDigOut = 0
  LowResADC
  ClearLamps
  ClearMotors
  
End Sub

Public Sub Pause(ByVal mSek As Long)

' --- Programm anhalten -------------------------------------

Dim sZeit&
  
  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.Pause", "Kein Open"
  sZeit = GetTickCount()
  
  Do
    DoEvents
      If ClearIfBreak Then Exit Sub
    Sleep 12                                               ' ----  besser PollInterval
  Loop While (GetTickCount() - sZeit < mSek)

End Sub

Public Sub Reset()

' ------ Rcksetzen der SmartBox ----------------------------------------

Dim res&, w&

  If WriteFile(comI, Chr$(2) & Chr$(255), 2, w, overL) = 0 Then _
     Err.Raise sbxErrBasis + 1, "FishSBox.Reset", "SmartBox Problem"

End Sub

Public Sub SetLamp(ByVal LampNr As sbxDigOut, ByVal OnOff As sbxDir)

' --- Setzen eines Digital-Ausganges ------------------------------------
  
Dim w&

  DoEvents
  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.SetLamp", "Kein Open"
  If ClearIfBreak Then Exit Sub
  FDigOut = FDigOut And Not SMaske(LampNr)
  If OnOff = sbxEin Then FDigOut = FDigOut Or SMaske(LampNr)
  If WriteFile(comI, Chr$(20) & Chr$(FDigOut), 2, w, overL) = 0 Then _
     Err.Raise sbxErrBasis + 1, "FishSBox.SetLamp", "SmartBox Problem"
  
End Sub

Public Sub SetLamps(ByVal DigOut As Long)

' --- Setzen eines Digital-Ausganges ------------------------------------

Dim w&

  DoEvents
  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.SetLamps", "Kein Open"
  If ClearIfBreak Then Exit Sub
  If WriteFile(comI, Chr$(20) & Chr$(DigOut), 2, w, overL) = 0 Then _
     Err.Raise sbxErrBasis + 1, "FishSBox.SetLamps", "SmartBox Problem"

End Sub

Public Sub SetMotor(ByVal MotorNr As sbxMotor, ByVal Direction As sbxDir)

' --- Setzen eines Motor-Ausganges -----------------------------------------

Dim res&, w&

  DoEvents
  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.SetMotor", "Kein Open"
  If ClearIfBreak Then Exit Sub
  Select Case Direction
  Case sbxLinks
    res = WriteFile(comI, Chr$(12) & Chr$(MotorNr), 2, w, overL)
  Case sbxRechts
    res = WriteFile(comI, Chr$(13) & Chr$(MotorNr), 2, w, overL)
  Case sbxAus
    res = WriteFile(comI, Chr$(14) & Chr$(MotorNr), 2, w, overL)
  Case Else
    res = 0
  End Select
  If res = 0 Then Err.Raise sbxErrBasis + 1, "FishSBox.SetMotor", "SmartBox Problem"
  
End Sub

Public Sub SetMotors(ByVal MotorStatus As Long)

' --- Setzen aller Motor-Ausgnge -------------------

Dim w&

  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.SetMotors", "Kein Open"
  If ClearIfBreak Then Exit Sub
  If WriteFile(comI, Chr$(10) & Chr$(MotorStatus), 2, w, overL) = 0 Then _
     Err.Raise sbxErrBasis + 1, "FishSBox.SetMotors", "SmartBox Problem"

End Sub

Public Property Let NotHalt(ByVal Wert As Boolean)
  FNotHalt = Wert
End Property
Public Property Get NotHalt() As Boolean
  NotHalt = False
End Property

Public Sub WaitForInput(ByVal InputNr As sbxDigIn, Optional ByVal OnOff As Boolean = True)

' --- Warten auf InputNr = OnOff ------------------------------------------

  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.WaitForInput", "Kein Open"
  Do
    If ClearIfBreak Then Exit Sub
    DoEvents
    Sleep 12                                   ' --- Besser PollInterval
  Loop While Not GetInput(InputNr) = OnOff

End Sub
Public Property Get MotorOuts() As Long
  
' ----- Auslesen Status der Motor-Ausgnge ----------------

Dim w&, wrk As String * 12

  If Not FOpen Then Err.Raise sbxErrBasis + 2, "FishSBox.MotorOuts", "Kein Open"
  If WriteFile(comI, Chr$(11), 1, w, overL) = 0 Then Err.Raise sbxErrBasis + 1, _
    "FishSBox.MotorOuts", "SmartBox Problem"
  If ReadFile(comI, wrk, 1, w, overL) = 0 Then Err.Raise sbxErrBasis + 1, _
    "FishSBox.MotorOuts", "SmartBox Problem"
  MotorOuts = Asc(wrk)

End Property

Public Property Get LampOuts() As Long
  LampOuts = FDigOut
End Property

Public Property Get Version() As String
  Version = App.Major & "." & App.Minor & "." & App.Revision
End Property

Private Sub Class_Initialize()

  SMaske(1) = &H1
  SMaske(2) = &H2
  SMaske(3) = &H4
  SMaske(4) = &H8
  SMaske(5) = &H10
  SMaske(6) = &H20
  SMaske(7) = &H40
  SMaske(8) = &H80
  
End Sub

Private Sub Class_Terminate()

  CloseInterface
  
End Sub


